#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityNationalDayMission.h"
std::auto_ptr<M_ActivityNationalDayMission> M_ActivityNationalDayMission::msSingleton(nullptr);

int M_ActivityNationalDayMission::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityNationalDayMissionData* M_ActivityNationalDayMission::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityNationalDayMissionData>& M_ActivityNationalDayMission::GetMapData()
{
	return mMapData;
}

void M_ActivityNationalDayMission::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityNationalDayMission.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityNationalDayMissionData data;
		data.mID = element->IntAttribute("ID");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mTaskName = element->Attribute("TaskName");
		data.mTaskDescription = element->Attribute("TaskDescription");
		data.mTheBranchLine = element->IntAttribute("TheBranchLine");
		data.mStage = element->IntAttribute("Stage");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mTaskIcon = element->Attribute("TaskIcon");
		data.mSecondaryInterfaceICON = element->Attribute("SecondaryInterfaceICON");
		data.mTaskStar = element->IntAttribute("TaskStar");
		data.mTaskLimits = element->IntAttribute("TaskLimits");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityNationalDayMission Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityNationalDayMission::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityNationalDayMission");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityNationalDayMission");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityNationalDayMissionData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readString(L, "TaskName", data.mTaskName);
		LuaCfgHelper::readString(L, "TaskDescription", data.mTaskDescription);
		LuaCfgHelper::readInt(L, "TheBranchLine", data.mTheBranchLine);
		LuaCfgHelper::readInt(L, "Stage", data.mStage);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readString(L, "TaskIcon", data.mTaskIcon);
		LuaCfgHelper::readString(L, "SecondaryInterfaceICON", data.mSecondaryInterfaceICON);
		LuaCfgHelper::readInt(L, "TaskStar", data.mTaskStar);
		LuaCfgHelper::readInt(L, "TaskLimits", data.mTaskLimits);
		LuaCfgHelper::readInt(L, "CompleteParam", data.mCompleteParam);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityNationalDayMission Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityNationalDayMission::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityNationalDayMission* M_ActivityNationalDayMission::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityNationalDayMission());
	}
	return msSingleton.get();
}

void M_ActivityNationalDayMission::Release()
{
	msSingleton.reset(nullptr);
}
